

#define SOFTWARE	"RingBuf.c"
#define DATUM		"01.07.2018 12:00"
#define AUTOR		"* Christof Ermer *"

#include <avr\io.h>
#include <stdint.h>
#include <stdlib.h>
#include "Befehle.h"
#include "RingBuf.h"

/* Umgewandelt in allgemeine RingBuffer funktion, mit Struktur Pointer
1. Type anlegen 
RINGBUF_TYPE  gsRxRingBuf;
2. Instanz Initialisieren mit Grsse 2^n
Init_RingBufBuf( &gsRxRingBuf, 256U );
*/
//#define RINGBUFF_SIZE 64 //2^n
// ACHTUNG uxArraySize = > 8 BIT weil 256 mglich sein muss

RINGBUF_TYPE gsMorseBuf;
uint8_t gau8MorseStr[ RINGBUFF_SIZE ]; // Power of 2^x <=256

// *********************************
void RingBuf_Init(RINGBUF_TYPE * pRBuf, uint8_t * pu8BufferStr, uint16_t uxArraySize) //always N^2 Size
// *********************************
{ // RingBuf_Init(&gsMorseBuf, gau8MorseStr, RINGBUFF_SIZE);
pRBuf->uxHead=0;
pRBuf->uxTail=0;	//uxHead = uxTail;
//U16ArraySize Immer N^2 BUF_STRMAX never >256,  or change the Datatype from  HEAD & TAIL to "unsigned int". 

// test if the size of the circular buffers fits into SRAM
pRBuf->uxRingBufMask = uxArraySize - 1;
//if( (pRBuf->pau8RingBuf = (uint8_t*) malloc( u16ArraySize ) ) == NULL )
pRBuf->pau8RingBuf =  pu8BufferStr;
*(pRBuf->pau8RingBuf) =  0;
};


// *********************************
void RingBuf_Flush(RINGBUF_TYPE * pRBuf)
// *********************************
{
pRBuf->uxHead=0;
pRBuf->uxTail=0;	//uxHead = uxTail;
};


//IMMER !!vorher Testen ob Platz,damit Zeichen nicht verloren geht.
// *********************************
void RingBuf_WriteC(RINGBUF_TYPE * pRBuf, uint8_t u8Rx)  //Rckgabeflag: Ok--> 0
// *********************************
{ // & uxRingBufMask ist Limit Size
pRBuf->uxHead = (pRBuf->uxHead + 1) & pRBuf->uxRingBufMask;
*(pRBuf->pau8RingBuf + pRBuf->uxHead) = u8Rx ;	
};


// *********************************
int RingBuf_ReadC( RINGBUF_TYPE * pRBuf )
// *********************************
{
if( pRBuf->uxHead == pRBuf->uxTail )
	{
	return RING_NO_DATA;
	};
/* calculate /store buffer index */	
pRBuf->uxTail = (pRBuf->uxTail+1) & pRBuf->uxRingBufMask; 
/* get data */
return *(pRBuf->pau8RingBuf + pRBuf->uxTail);    
};

#ifdef OVL_CHECK_USED
// **************************
int RingBuf_Check_Overload(RINGBUF_TYPE * pRBuf) /* Overload State? RingBuf ? */
// **************************
{
if( ((pRBuf->uxHead  + 1) & pRBuf->uxRingBufMask) == pRBuf->uxTail )
	{
	return RING_OVL; // returnflag: RXSTRBUF_OVL --> !=0
	};
return RING_OK;
}; 
#endif

// **************************
#ifdef BIT8_RINGBUF_USED
extern uint8_t RingBuf_Bytes_Available(RINGBUF_TYPE * pRBuf) /* Bytes im RingBuf ? */
#endif
#ifdef BIT16_RINGBUF_USED
extern uint16_t RingBuf_Bytes_Available(RINGBUF_TYPE * pRBuf) /* Bytes im RingBuf ? */
#endif
// **************************
{ // Hier Modulo  % pRBuf->uxRingBufMask
return ((pRBuf->uxRingBufMask + pRBuf->uxHead - pRBuf->uxTail) % pRBuf->uxRingBufMask);
}; 


#ifdef RINGBUF_TEST_USED
// *********************************
char * CopyRingbufToStr(RINGBUF_TYPE * pRBuf, char * pcStr, uint8_t u8Cnt)  //Monitoring Content
// *********************************
{
uint8_t u8Pos;
*pcStr=0;
//for( u8Pos=0; u8Pos < RingBuf_Bytes_Available( pRBuf ); )
for( u8Pos=0; u8Pos < u8Cnt; u8Pos++)
	{
	*(pcStr + u8Pos) = *(pRBuf->pau8RingBuf + u8Pos);
	*(pcStr + u8Pos + 1) = 0;
	};
return pcStr;  
};
#endif
