

#define SOFTWARE	"KURS 2020"
#define DATUM		"24.06.2020"
/*
Christof Ermer 
QUELLE:  X:\000_Kurs2020_ATMega328p_Progs


gstFlags.AutoMorse_Flag triggert dauersenden eines testTextes

Morse TON geht ber Timer 1 = OC1A = PB1
Morsesignal  PD3  ( aucg fr IR Sender -->Daten
Timer 2 = OC2A = PB3  = 36KHz fr IR Sender
Es sollte noch ein BUSY Signal geben,  fr TExtsender RTS/CTS


Funktion: 
Bibliothek: file:///C:/WinAVR-20100110/doc/avr-libc/avr-libc-user-manual/modules.html
Controller Defines, File Explorer: C:\WinAVR-20100110\avr\include\avr\iom328p.h
int8_t uint8_t int16_t uint16_t int32_t uint32_t ISR main
*/
/* -----------------------------------------------
 Programmed by Christof Ermer
 https://homepages.uni-regensburg.de/~erc24492/
  ------------------------------------------------
*/

#define AUTOR		"* Christof Ermer *"
#define HARDWARE	"Arduino UNO ATMega328p"
#define IHAVENOBRAIN	"*Habe kein Hirn*"	
#define USEYOURS		"*benutze Deins!*"

#include "main.h"		//with Hardware assign
// Globale Variablen

//const char PROGMEM TxMorseTestStr[] = {"Karl Marx. Das Kapital. Kritik der politischen Oekonomie."};  // zum TEsten
const char PROGMEM TxMorseTestStr[] = {"Start. Junikaefer an Walkuere. Der Pirol pfeift heute Nacht. Norwind blaest im Ofenrohr. Stop. "};  // zum TEsten


volatile uint32_t gu32Ticks;

volatile BIT_FIELD_TYPE gstFlags;

uint8_t gcaLcd16[LCD_ROWS + 1];
// SO wrs richtig, weil es in den FlashSpeicher abgelegt wird
const char MCA_LCD_16SPACE[] PROGMEM = "                ";  // 16 Leer Stellen

#ifdef I2C_LCD_USED
// ************************************
void LCDShiftChars( uint8_t u8Char )
//Inclusive Umschichtung, Rollen von Rechts nach Links
// ************************************
{ //LCD_ROWS
uint8_t u8NN = 0;
if( *(gcaLcd16) == 0 ) 
	{
	strcpy_P((char*)gcaLcd16, MCA_LCD_16SPACE); 
	};

for(u8NN = 0; u8NN < LCD_ROWS; u8NN++)
	{
	*(gcaLcd16 + u8NN) = *(gcaLcd16 + (u8NN+1));
	};
*(gcaLcd16 + (LCD_ROWS-1) ) = u8Char; 
*(gcaLcd16 + LCD_ROWS) = 0; 
lcd_printlc(1,1, gcaLcd16);
};
#endif


// ***********************
ISR( TIMER0_COMPA_vect ) // 1000 */sec   /(250* bei //256)
// ***********************
{
gu32Ticks++;  // 250/Sekunde

ManageTxInterrupt();
if( !(gu32Ticks % TICKS_1000MS) ) //Modulo ==0 ?
	{
	gstFlags.TICK_1000MS_Flag = 1;	//Set FLAG	
	};

if( !(gu32Ticks % TICKS_25MS) )
	{
	gstFlags.TICK_25MS_Flag = 1;
	};
	
if( !(gu32Ticks % TICKS_100MS) )
	{
	gstFlags.TICK_100MS_Flag = 1;
	UART_RX_Check(); // Polling 
	};

if( !(gu32Ticks % TICKS_3000MS) )
	{
	gstFlags.TICK_3SEC_Flag = 1;
	};
};

/*
// *****************************
void StartTickTimer( void ) // /250
// *****************************
{
// Timer TickCounter starten im Compare Mode
// M_CPU=16^6 / 256 / 250 = {ebenso} 250!Zhle 0 bis 250-->exakt 1 SeKunde
TCNT0 = 0;
OCR0A = 250;//Compare Value
TCCR0A = (1<< WGM01);	//CTC Mode = Compare Timer Counter mit OCR0A
TIMSK0 = (1<< OCIE0A);	//Compare Interrupt aktivieren
TCCR0B = (1<< CS02);	//Vorteiler /256
//TCCR0B = (1<< CS02) | _BV(CS00);	//Vorteiler /1024
};
*/

// *****************************
void StartTickTimer( void ) // /64
// *****************************
{
// Timer TickCounter starten im Compare Mode
// M_CPU=16^6 / 256 / 250 = {ebenso} 250!Zhle 0 bis 250-->exakt 1 SeKunde
gu32Ticks = 0;
TCNT0 = 0;
OCR0A = 250;//Compare Value
TCCR0A = (1<< WGM01);	//CTC Mode = Compare Timer Counter mit OCR0A
TIMSK0 = (1<< OCIE0A);	//Compare Interrupt aktivieren
TCCR0B =  (1<< CS01) | _BV(CS00);	// /64=25000/250=1000=1S
//TCCR0B = (1<< CS02);	//Vorteiler /256
//TCCR0B = (1<< CS02) | _BV(CS00);	//Vorteiler /1024
};


// *****************
int main(void)
// *****************
{
//Port direction setting
uint8_t u8NN=0;
uint16_t u16MT=0;
uint32_t u32Speed=0;

#ifdef SHIFT74595_USED
OUT_74595_InitDDRegs();
#endif

#ifdef MAX7219_USED
//OUT_74595_InitDDRegs();
MAX7219_Init();
MAX7219_Clear();
MAX7219_SetBrightness(1);
#endif

#ifdef I2C_USED
// TWI initialisieren
i2c_init();
#endif

#ifdef I2C_LCD_USED	// LCD initialisieren
lcd_init();
// LCD-Anzeige loeschen
lcd_command(LCD_CLEAR);
// Hintergrundbeleuchtung an
lcd_backlight(ON);
/// Text auf LCD ausgeben
// MIT RAM , als falsch
strcpy_P( gcaStr, PSTR("* I2C LCD *") );
lcd_printlc(1,1,(unsigned char *)gcaStr);
strcpy_P( gcaStr, PSTR("*Christof Ermer*"));
lcd_printlc(2,1,(unsigned char *)gcaStr);
#endif 

#ifdef UART_USE_ENABLED
uart_init( UART_BAUD_SELECT_DOUBLE_SPEED( 115200UL, F_CPU) );
ResetRxBuff();
#endif

wdt_reset();  
wdt_enable(WDTO_1S); //Totmannknopf
wdt_reset();  

StartTickTimer();

gstFlags.Geschwaetzig = 1;
gstFlags.AutoMorse_Flag = 1 ;
gstFlags.TX_Morse_Sofort_Flag = 0;

gstMorseTx.Morse_SoundOn = 1;

#ifdef MORSE_TX_USED
Init_MorseTx();   //Start_72KHZ();
#endif

 
sei();  //Es sei! Interrupt einschalten
while(1) /* loop forever */
	{
	wdt_reset();  
	u32Speed++;
	//Toggle_Bit( 1 );	
 
	if(	gstFlags.TICK_25MS_Flag )  // Ask Flag == TRUE
		{
		gstFlags.TICK_25MS_Flag = 0;

		MorseBuf_Polling();
	
		u16MT = (gstMorseTx.TXBYte_OK)
			| (gstMorseTx. PSP_JobStart << 1)
			| (gstMorseTx.PSP_JobActive << 2)
			| (gstMorseTx.PSP_TXActive << 3)
			| (gstMorseTx.TX_Punkt << 4)
			| (gstMorseTx.TX_Strich << 5)
			| (gstMorseTx.TX_Pause << 6)
			| (gstMorseTx.StrReady << 7)			
			;
			//gstMorseTx.Morse_Busy 
#ifdef SHIFT74595_USED
		OUT_74595( u16MT );		
#endif		
		};
	
	if(	gstFlags.TICK_3SEC_Flag )  // Ask Flag == TRUE
		{
		gstFlags.TICK_3SEC_Flag = 0;

#ifdef MORSE_TX_USED
		if( !(gstMorseTx.PSP_JobActive || gstFlags.AutoMorse_Flag) )
			{
			if( !RingBuf_Bytes_Available(&gsMorseBuf) ) 			
				{			
				strcpy_P( gcaStr, TxMorseTestStr );
				//strcpy_P( gcaStr, TxText );				
				TxMorseStr( gcaStr );
				//TxMorseByte( 'F' );			
				};
			};
#endif
		};
	
	if(	gstFlags.TICK_100MS_Flag )  // Ask Flag == TRUE
		{
		gstFlags.TICK_100MS_Flag = 0;
#ifdef MORSE_TX_USED		
		//u16MT = (gstMorseTx.TX_ACTIVE);
#endif

#ifdef MAX7219_USED
		u8NN++;
		u8NN %= 8;		
		MAX7219_Write(1, _BV(u8NN) );
		MAX7219_Write(2, (u16MT & 0xFF) );	

		MAX7219_Write(4, gstMorseTx.u8MorseVal );
		MAX7219_Write(5, gstMorseTx.u8CodeOffset );		
		
		MAX7219_Write(6, (gstFlags.TX_Morse_Sofort_Flag));
		MAX7219_Write(7, (gstFlags.AutoMorse_Flag));
		MAX7219_Write(8, (gstMorseTx.Morse_Busy  ) );
#endif		
		};
		
	if( gstFlags.TICK_1000MS_Flag )  // ?-->1
		{
		gstFlags.TICK_1000MS_Flag = 0; // clear Flag	
#ifdef MORSE_TX_USED		

/*		
		uart_puts_p(PSTR("\tMorsespeed:") );			
		uart_puts( UIntToNumStr( gstMorseTx.u16MorseSpeed ) );	

		uart_puts_p(PSTR("\tTonF:") );			
		uart_puts( UIntToNumStr( gstMorseTx.u16MorseTonFrq ) );	

		uart_puts_p(PSTR("\tSigZeit:") );			
		uart_puts( ULongToNumStr( gstMorseTx.u16SignalTxZeit ) );	
		uart_puts_p(PSTR("\r\n\tFlags") );			
		uart_puts( WordToBin( u16MT ) );	
*/
#endif
		
#ifdef I2C_LCD_USED		
//		lcd_command(LCD_CLEAR);	
	
/*
		strcpy_P(gcaStr, PSTR("T") );
		LongToNumStr(gu32Ticks);
		strcat(gcaStr, gcaNumStr );		
		//strcpy_P(gcaStr, PSTR(" ADC:") );
		//UIntToNumStr( u16Frq );
		
		strcat_P(gcaStr, PSTR(" S") );
		ULongToNumStr(u32Speed);
		u32Speed=0;
		strcat( gcaStr, gcaNumStr );
		lcd_printlc(1,1,(unsigned char *)gcaStr);
*/
		lcd_printlc(2,1,(unsigned char *)ByteToBin( u16MT));
		

#endif

#ifdef UART_USE_ENABLED
		if(gstFlags.Geschwaetzig)
			{
//			uart_puts_p(PSTR("\n\rTick:") );		
//			uart_puts( ULongToNumStr( gu32Ticks ) );	
		
			};//Geschwtzigf
#endif //Uart		
		}; // TICK
			
#ifdef UART_USE_ENABLED
	if( gsCmd.UartCREventFlag ) // bearbeite Carriage Return Order
		{
		gsCmd.UartCREventFlag = 0;
		CheckOrder();
		ResetRxBuff();
		};
#endif
	}; //while

};
// ******** MAIN END ********
